<?php

function check_xray_upgrade() {
	echo <<<EOB
		<h2>APCu Version Information</h2>
		<table cellspacing=0><tbody>
		<tr>
		<th></th>
		</tr>
EOB;
	if (defined ('PROXY')) {
		$ctxt = stream_context_create (array(
			'http' => array(
				'proxy' => PROXY,
				'request_fulluri' => true
			)
		));
		$rss = @file_get_contents ("http://pecl.php.net/feeds/pkg_apcu.rss", false, $ctxt);
	} else {
		$rss = @file_get_contents ("http://pecl.php.net/feeds/pkg_apcu.rss");
	}
	if (!$rss) {
		echo '<tr class="td-last center"><td>Unable to fetch version information.</td></tr>';
	} else {
		$apcversion = phpversion ('apcu');

		preg_match ('!<title>APCu ([0-9.]+)</title>!', $rss, $match);
		echo '<tr class="tr-0 center"><td>';
		if (version_compare ($apcversion, $match[1], '>=')) {
			echo '<div class="ok">You are running the latest version of APCu (' . $apcversion . ')</div>';
			$i = 3;
		} else {
			echo '<div class="failed">You are running an older version of APCu (' . $apcversion . '),
				newer version ' . $match[1] . ' is available at <a href="http://pecl.php.net/package/APCu/' . $match[1] . '">
				http://pecl.php.net/package/APCu/' . $match[1] . '</a>
				</div>';
			$i = -1;
		}
		echo '</td></tr>';
		echo '<tr class="tr-0"><td><h3>Change Log:</h3><br/>';

		preg_match_all ('!<(title|description)>([^<]+)</\\1>!', $rss, $match);
		$changelog = $match[2];

		for ($j = 2; $j + 1 < count ($changelog); $j += 2) {
			$v = $changelog[$j];
			list($unused, $ver) = $v;
			if ($i < 0 && version_compare ($apcversion, $ver, '>=')) {
				break;
			} elseif (!$i--) {
				break;
			}
			$changes = $changelog[$j + 1];
			echo "<b><a href=\"http://pecl.php.net/package/APCu/$ver\">" . htmlspecialchars ($v, ENT_QUOTES, 'UTF-8') . "</a></b><br><blockquote>";
			echo nl2br (htmlspecialchars ($changes, ENT_QUOTES, 'UTF-8')) . "</blockquote>";
		}
		echo '</td></tr><tr><td>La mise à jour n’est pas possible indépendamment de XRay</td></tr>';
	}
	echo "</tbody></table>";
}